#!/usr/bin/sh
export CMU='/home/s0455377/CMU-toolkit/CMU-Cam_Toolkit_v2/bin/'

perl -pe 's/^/\# /; s/$/ \#/;' $1 | uniq > training.txt

cat training.txt | $CMU/text2wfreq | $CMU/wfreq2vocab -top 60000 > training.vocab

cat training.txt | $CMU/text2idngram -n 2 -vocab training.vocab -buffer 100 > training.id2gram

$CMU/idngram2lm  -idngram training.id2gram -vocab training.vocab -n 2 -binary training.2gram.binlm -cutoffs 1 -witten_bell

rm training.id2gram training.vocab # training.txt

mv $2 disambiguate.txt

echo "perplexity -text disambiguate.txt -probs model.fprobs -annotate model.annotation_file" | $CMU/evallm -binary training.2gram.binlm

rm model.fprobs

echo -e "\ncalculating probabilities of analyses..."

perl -e 'while(<>){
/P\( (\S+) \| (\S+) \) = .+ logprob = (-\d\.\d+)\s.*$/; 
$a = $1; $z = $2; $l = $3; 
if($a eq "#" and $z eq "#"){
@s = split /\s+/,$w; 
if ($no == 0){$no = 1;} 
printf $w." %2.3f\n", $p+log($no); 
$w = ""; $p = 0; $no = 0; next;}
else{$w .= $z." ";$p += $l; $no ++;}
} print " 0.000\n";' model.annotation_file > probs

echo "printing best analysis for each word..."

perl -e '$bestscore = 99; $bestscoreunk = 99; open (BA, "disambiguate.txt"); @ba = <BA>;while(<>){  if (/^\s+0(\.000)?\s*$/){if ($bestscore <99){print $ba[$best];}else{print $ba[$bestUnk];}$bestscore = 99; $bestscoreunk = 99;} else{ s/\# //; /^(.*)\s+\-(\d+\.\d+)$/; $w = $1; $d = $2 * 1;  if ($d < $bestscore and not $w =~ /UNK/){$best = $i; $bestscore = $d; } elsif($d < $bestscoreunk and $w =~ /UNK/){$bestUnk = $i; $bestscoreunk = $d;} } $i++; }' probs > $2.disambig

mv disambiguate.txt $2

rm model.annotation_file probs 

perl -i -pe 's/^\# //; s/ \#$//;' $2.disambig

rm $2
